﻿using System;

using Android.App;
using Android.Content;
using Android.OS;
using System.Threading;
using Android.Media;

namespace WSTests.Droid
{
    [Service(Exported = true)]
    public class SimpleService : Service
    {
        static readonly int TimerWait = 5000;
        Timer timer;
        DateTime startTime;
        bool isStarted;

        public override void OnCreate()
        {
            base.OnCreate();
        }

        public override StartCommandResult OnStartCommand(Intent intent, StartCommandFlags flags, int startId)
        {
            if (isStarted)
            {
                //PlaySound();
            }
            else
            {
                isStarted = true;
                //PlaySound();
                timer = new Timer(HandleTimerCallback, startTime, 0, TimerWait);
            }

            return StartCommandResult.Sticky;
        }

        public override IBinder OnBind(Intent intent) => null;

        public override void OnDestroy()
        {
            PlaySound();

            timer.Dispose();
            timer = null;

            base.OnDestroy();
        }

        void HandleTimerCallback(object state) => PlaySound();

        public void PlaySound()
        {
            try
            {
                var notification = RingtoneManager.GetDefaultUri(RingtoneType.Notification);
                Ringtone r = RingtoneManager.GetRingtone(Android.App.Application.Context, notification);
                r.Play();
            }
            catch (Exception e)
            {
            }
        }
    }
}